Summary: The Perl programming language.
Name: perl
%define perlver 5.6.0
Version: %{perlver}
Vendor: Guardian Digital, Inc.
Packager: Guardian Digital, Inc. <http://www.linuxseclabs.com>
Release: 1.3.0
Copyright: GPL
Group: Development/Languages
Source0: ftp://ftp.perl.org/pub/perl/CPAN/src/perl-%{perlver}.tar.gz
Source1: ftp://ftp.perl.org/pub/CPAN/modules/by-module/Digest/Digest-MD5-2.09.tar.gz
Source2: find-provides
Source3: find-requires
Patch0: perl5.005_02-buildsys.patch
Patch1: perl-5.6.0-installman.patch
Patch2: perl5.005_03-db1.patch
Patch3: perl-5.6.0-nodb.patch
Patch4: perl-5.6.0-prereq.patch
Patch5: perl-5.6.0-root.patch
Patch6: perl-5.6.0-fhs.patch
Patch7: perl-5.6.0-buildroot.patch
Patch8: perl-5.6.0-errno.patch
Patch9: perl-5.6.0-syslog.patch
Patch10: perl-5.6.0-NDBM_File-gdbm-link-fix-gd-1.diff
Obsoletes: perl-MD5, perl-Digest-MD5
Buildroot: %{_tmppath}/%{name}-root
BuildPreReq: gawk, grep, tcsh

# ----- Perl module dependencies.
#
# Provide perl-specific find-{provides,requires} until rpm-3.0.4 catches up.
%define	__find_provides	%{SOURCE2}
%define	__find_requires	%{SOURCE3}

# By definition of 'do' (see 'man perlfunc') this package provides all
# versions of perl previous to it.
Provides: perl <= %{version}

# These modules appear to be missing or break assumptions made by the
# dependency analysis tools.  Typical problems include refering to
# CGI::Apache as Apache and having no package line in CPAN::Nox.pm. I
# hope that the perl people fix these to work with our dependency
# engine or give us better dependency tools.
#
# Provides: perl(Apache)
# Provides: perl(ExtUtils::MM_Mac)
# Provides: perl(ExtUtils::XSSymSet)
# Provides: perl(FCGI)
# Provides: perl(LWP::UserAgent)
# Provides: perl(Mac::Files)
# Provides: perl(URI::URL)
# Provides: perl(VMS::Filespec)

%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications are system
administration utilities and web programming.  A large proportion of
the CGI scripts on the web are written in Perl.  You need the perl
package installed on your system so that your system can handle Perl
scripts.

Install this package if you want to program in Perl or enable your
system to handle Perl scripts.

%prep
%setup -q
mkdir modules
tar xzf %{SOURCE1} -C modules
%patch0 -p1 -b .buildsys
%patch1 -p1 -b .instman
# Perl does not have a single entry point to define what db library to use
# so the patch below is mostly broken...
#%patch2 -p1
%patch3 -p1 -b .nodb
%patch4 -p1 -b .prereq
%patch5 -p1 -b .root
%patch6 -p1 -b .fhs
%patch7 -p1 -b .buildroot
%patch8 -p1 -b .errno
%patch9 -p1
%patch10 -p1

find . -name \*.orig -exec rm -fv {} \;

%build
# Building with no "suidperl" compiled by 
# "-Dd_dosuid='no'" Configure option

[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
sh Configure -des -Doptimize="$RPM_OPT_FLAGS" \
	-Dcc='%{__cc}' \
	-Dcccdlflags='-fPIC' \
	-Dinstallprefix=$RPM_BUILD_ROOT%{_prefix} \
	-Dprefix=%{_prefix} \
	-Darchname=%{_arch}-%{_os} \
	-Dd_dosuid \
%ifarch sparc
	-Ud_longdbl \
%endif
	-Dd_semctl_semun \
	-Di_db \
	-Di_ndbm \
	-Di_gdbm \
	-Di_shadow \
	-Di_syslog \
	-Dman3ext=3pm \
	-Uuselargefiles
make -f Makefile

# Build the modules we have
MainDir=$(pwd)
cd modules
for module in * ; do 
    cd $module
    $MainDir/perl -I$MainDir/lib Makefile.PL
    make
    cd ..
done
cd $MainDir

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

make install -f Makefile
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
install -m 755 utils/pl2pm ${RPM_BUILD_ROOT}%{_bindir}/pl2pm

# Generate *.ph files with a trick. Is this sick or what ?
make all -f - <<EOF
PKGS	= glibc-devel gdbm-devel gpm-devel libgr-devel libjpeg-devel \
	  libpng-devel libtiff-devel ncurses-devel popt \
	  zlib-devel binutils libelf e2fsprogs-devel pam pwdb \
	  rpm-devel
STDH	= \$(filter %{_includedir}/include/%%, \$(shell rpm -q --queryformat '[%%{FILENAMES}\n]' \$(PKGS)))
STDH	+=\$(wildcard %{_includedir}/linux/*.h) \$(wildcard %{_includedir}/asm/*.h) \
	  \$(wildcard %{_includedir}/scsi/*.h)
GCCDIR	= \$(shell gcc --print-file-name include)
GCCH	= \$(filter \$(GCCDIR)/%%, \$(shell rpm -q --queryformat '[%%{FILEMODES} %%{FILENAMES}\n]' gcc | grep -v ^4 | awk '{print $NF}'))

PERLLIB = \$(RPM_BUILD_ROOT)%{_libdir}/perl5/%{perlver}
PERL	= PERL5LIB=\$(PERLLIB) \$(RPM_BUILD_ROOT)%{_bindir}/perl
PHDIR	= \$(PERLLIB)/\${RPM_ARCH}-linux*
H2PH	= \$(PERL) \$(RPM_BUILD_ROOT)%{_bindir}/h2ph -d \$(PHDIR)/

all: std-headers gcc-headers fix-config

std-headers: \$(STDH)
	cd %{_includedir} && \$(H2PH) \$(STDH:%{_includedir}/%%=%%)

gcc-headers: \$(GCCH)
	cd \$(GCCDIR) && \$(H2PH) \$(GCCH:\$(GCCDIR)/%%=%%) || true

fix-config: \$(PHDIR)/Config.pm
	\$(PERL) -i -p -e "s|\$(RPM_BUILD_ROOT)||g;" \$<

EOF

# Now pay attention to the extra modules
MainDir=$(pwd)
pushd modules
for module in * ; do 
    eval $($MainDir/perl '-V:installarchlib')
    mkdir -p $RPM_BUILD_ROOT/$installarchlib
    make -C $module install
done
popd
#cd $MainDir

# fix the rest of the stuff
find $RPM_BUILD_ROOT%{_libdir}/perl* -name .packlist -o -name perllocal.pod | \
xargs ./perl -i -p -e "s|$RPM_BUILD_ROOT||g;" $packlist

# Remove duplicate copy of suidperl.
rm -f $RPM_BUILD_ROOT/usr/bin/sperl5.6.0

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_bindir}/*
%{_libdir}/*
/usr/share/man/*

%changelog
* Thu Apr 10 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.3.0
  - Initial build for EnGarde Secure Community 2 (Feint).

* Mon Mar 03 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.6.0, Release 1.5.2
  - Rebuild so it picks up the right db libs.

* Fri Feb 21 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.6.0, Release 1.5.1
  - Link NDBM_File.so against libgdbm, not db2.
  - Enable patch #9 (syslog suidperl alerts).

* Mon Feb 03 2003 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.5.0
  - Initial build for EnGarde v1.5 (Thrust).

* Thu May 16 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.6.0, Release 1.2.1
  - Remove duplicate copy of suidperl as per Rabon audit.

* Mon Feb 11 2002 Ryan W. Maple <ryan@guardiandigital.com>
- Release 1.2.0
  - Initial build for EnGarde v1.2 (Parry).

* Tue Oct 23 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.6.0, Release 1.1.3
  - Removed Serial tag.

* Tue Oct 02 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.6.0, Release 1.1.2
  - "Epoch" -> "Serial"
  - Increased Serial to 2.

* Thu Sep 13 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.6.0, Release 1.1.1
  - Sanitized OLD RH changelog.  Will Ryan-ize spec in the near future.
  - Build suidperl and include in package.

* Tue Aug 07 2001 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.6.0, Release 1.1.0
  - Initial build for EnGarde v1.1 (Balestra).

* Mon Dec 04 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Okay, I'm dumb.  Removed perarch macro alltogether as now it causes the rpm
  not to build. :)  Larry Wall is God.

* Sat Dec 02 2000 Ryan W. Maple <ryan@guardiandigital.com>
- Defined perlarch to i686 so the modules end up in the correct place.
- Originally tried to put them all in i386, but changed my mind.

* Fri Sep 29 2000 Pete O'Hara <pete@guardiandigital.com>
- %files needed to specify /usr/share/man/* to find man pages

